package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.UserRoleData;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleData_Grid_Main{
    private String memo;
    private Integer secdr;
    private String dstorgsectorid;
    private String userroledataid;
    private String dename;
    private String updateman;
    private String dstorgid;
    private String srfmajortext;


    private String srfkey;


    private String srfdataaccaction;


    private Integer orgdr;
    private String deid;
    private String userroledataname;
    private Integer isalldata;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    public  void fromUserRoleData(UserRoleData sourceEntity)  {
         this.setMemo(sourceEntity.getMemo());
         this.setSecdr(sourceEntity.getSecdr());
         this.setDstorgsectorid(sourceEntity.getDstorgsectorid());
         this.setUserroledataid(sourceEntity.getUserroledataid());
         this.setDename(sourceEntity.getDename());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setDstorgid(sourceEntity.getDstorgid());
         this.setSrfmajortext(sourceEntity.getUserroledataname());
         this.setSrfkey(sourceEntity.getUserroledataid());
         this.setSrfdataaccaction(sourceEntity.getUserroledataid());
         this.setOrgdr(sourceEntity.getOrgdr());
         this.setDeid(sourceEntity.getDeid());
         this.setUserroledataname(sourceEntity.getUserroledataname());
         this.setIsalldata(sourceEntity.getIsalldata());
         this.setUpdatedate(sourceEntity.getUpdatedate());
	}

	public static Page<UserRoleData_Grid_Main> fromUserRoleData(Page<UserRoleData> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<UserRoleData_Grid_Main> targetpage=new Page<UserRoleData_Grid_Main>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<UserRoleData_Grid_Main> records=new ArrayList<UserRoleData_Grid_Main>();
        for(UserRoleData source:sourcePage.getRecords()) {
            UserRoleData_Grid_Main target=new UserRoleData_Grid_Main();
            target.fromUserRoleData(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("dename","数据对象"); }});
        columnModelList.add(new HashMap(){ { put("userroledataname","能力名称"); }});
        columnModelList.add(new HashMap(){ { put("orgdr","机构数据类型"); }});
        columnModelList.add(new HashMap(){ { put("secdr","部门数据类型"); }});
        columnModelList.add(new HashMap(){ { put("isalldata","全部数据"); }});
        columnModelList.add(new HashMap(){ { put("memo","备注"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<UserRoleData> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(UserRoleData source:searchResult.getRecords()) {
            UserRoleData_Grid_Main target=new UserRoleData_Grid_Main();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<UserRoleData> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}